/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//---------------------------------------------------------------------------
int HexRead4(char *s)
{
	int a;
	a=s[0];
    a=toupper(a);
    a-='0';
    if(a>9) a-=7;
	return(a);
}

int HexRead8(char *s)
{
	int a;
	a =HexRead4(s) << 4;
	a|=HexRead4(s+1);
	return(a);
}

int HexRead16(char *s)
{
	int	a;
	a =HexRead8(s) << 8;
	a|=HexRead8(s+2);
	return(a);
}

/***********************************************************************
Lecture de fichiers .Hex
***********************************************************************/

int HexRead(char *FileName,char *Data,int MaxLength)
{
	FILE 	*stream;
	int		i,j,k;
	int		bc,addr,type;
    char    tmpString[256];

	stream=fopen(FileName,"r");
	if(!stream)	return(1);

	// lecture fichier
	while(1)
	{
		// ligne
		fgets(tmpString,255,stream);
		if(feof(stream)) break;

		// CR
		if(tmpString[strlen(tmpString)-1]=='\n')
			tmpString[strlen(tmpString)-1]=0;

		// vrifie premier caractre
		if(tmpString[0]!=':')	return(2);

		// lit nb octets,adresse et type de l'enregistrement
		bc=HexRead8(&tmpString[1]);
		addr=HexRead16(&tmpString[3]);
		type=HexRead8(&tmpString[7]);

		// si le type=1, lecture termine
		if(type==1) break;

		// type!=0 : inconnu.
		if(type!=0)
		{
//			printf("warning: ignoring unrecognised type field: $%02lx\n",type);
			continue;
		}

		// lecture donnes
		for(i=0;i<bc;i+=1)
		{
			j=HexRead8(&tmpString[9+(2*i)]);
			k=(addr+i);
            if (k<MaxLength) Data[k]=(byte)j;
		}
	}

	// close file
	fclose(stream);
	return(0);
}


//---------------------------------------------------------------------------
#ifndef __linux__
#pragma package(smart_init)
#endif
